#version 150

#moj_import <fog.glsl>

in vec3 Position;
in vec4 Color;
in vec2 UV0;
in ivec2 UV2;

uniform sampler2D Sampler2;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform float GameTime;
uniform int FogShape;

out float vertexDistance;
out vec4 vertexColor;
out vec2 texCoord0;

void main() {
  vec4 vertex = vec4(Position, 1.0);
  if (Color.xyz == vec3(255., 255., 254.) / 255.) {
    (gl_Position = ProjMat * ModelViewMat * vertex);
    (vertexColor = ((.6 + .6 * cos(6. * (gl_Position.x + GameTime * 1000.) + vec4(0, 23, 21, 1))) + vec4(0., 0., 0., 1.)) * texelFetch(Sampler2, UV2 / 16, 0));
  } else if (Color.xyz == vec3(255., 255., 253.) / 255.) {
    (gl_Position = ProjMat * ModelViewMat * vertex);
    (vertexColor = Color * texelFetch(Sampler2, UV2 / 16, 0));
    (gl_Position.y = gl_Position.y + sin(GameTime * 12000. + (gl_Position.x * 6)) / 150.);
  } else if (Color.xyz == vec3(255., 255., 252.) / 255.) {
    (gl_Position = ProjMat * ModelViewMat * vertex);
    (vertexColor = ((.6 + .6 * cos(6. * (gl_Position.x + GameTime * 1000.) + vec4(0, 23, 21, 1))) + vec4(0., 0., 0., 1.)) * texelFetch(Sampler2, UV2 / 16, 0));
    (gl_Position.y = gl_Position.y + sin(GameTime * 12000. + (gl_Position.x * 6)) / 150.);
  } else if (Color.xyz == vec3(255., 255., 251.) / 255.) {
    (vertexColor = Color * texelFetch(Sampler2, UV2 / 16, 0));
    float vertexId = mod(gl_VertexID, 4.0);
    if (vertex.z <= 0.) {
      if (vertexId == 3. || vertexId == 0.) vertex.y += cos(GameTime * 12000. / 4) * 0.1;
      vertex.y += max(cos(GameTime * 12000. / 4) * 0.1, 0.);
    } else {
      if (vertexId == 3. || vertexId == 0.) vertex.y -= cos(GameTime * 12000. / 4) * 3;
      vertex.y -= max(cos(GameTime * 12000. / 4) * 4, 0.);
    }(gl_Position = ProjMat * ModelViewMat * vertex);
  } else if (Color.xyz == vec3(255., 254., 254.) / 255.) {
    float vertexId = mod(gl_VertexID, 4.0);
    if (vertex.z <= 0.) {
      if (vertexId == 3. || vertexId == 0.) vertex.y += cos(GameTime * 12000. / 4) * 0.1;
      vertex.y += max(cos(GameTime * 12000. / 4) * 0.1, 0.);
    } else {
      if (vertexId == 3. || vertexId == 0.) vertex.y -= cos(GameTime * 12000. / 4) * 3;
      vertex.y -= max(cos(GameTime * 12000. / 4) * 4, 0.);
    }(vertexColor = ((.6 + .6 * cos(6. * (gl_Position.x + GameTime * 1000.) + vec4(0, 23, 21, 1))) + vec4(0., 0., 0., 1.)) * texelFetch(Sampler2, UV2 / 16, 0));
    (gl_Position = ProjMat * ModelViewMat * vertex);
  } else {
    (gl_Position = ProjMat * ModelViewMat * vertex);
    (vertexColor = Color * texelFetch(Sampler2, UV2 / 16, 0));
  }
  vertexDistance = length((ModelViewMat * vertex).xyz);
  texCoord0 = UV0;
  ivec3 iColor = ivec3(Color.xyz * 255 + vec3(0.5));
  if (iColor == ivec3(78, 92, 36) && (
      Position.z == 0.03 || // Actionbar
      Position.z == 0.06 || // Subtitle
      Position.z == 0.12 || // Title
      Position.z == 100.03 || // Chat
      Position.z == 200.03 || // Advancement Screen
      Position.z == 400.03 // Items
    )) { // Regular text
    vertexColor.rgb = texelFetch(Sampler2, UV2 / 16, 0).rgb; // Remove color from no shadow marker
  } else if (iColor == ivec3(19, 23, 9) && (
      Position.z == 0 || // Actionbar | Subtitle | Title
      Position.z == 100 || // Chat
      Position.z == 200 || // Advancement Screen
      Position.z == 400 // Items
    )) { // Shadow
    gl_Position = vec4(2, 2, 2, 1); // Move shadow off screen
  }
}